<?php
/**
 * @package     Joomla.Site
 * @subpackage  Templates.protostar
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

$app             = JFactory::getApplication();
$doc             = JFactory::getDocument();
$user            = JFactory::getUser();
$this->language  = $doc->language;
$this->direction = $doc->direction;

$doc = JFactory::getDocument();

//remove un necessary files
$dontInclude = array(
'/media/jui/js/jquery.js',
JURI::root(true) .'/media/jui/js/jquery.min.js',
JURI::root(true) .'/media/jui/js/jquery-noconflict.js',
JURI::root(true) .'/media/jui/js/jquery-migrate.min.js',
JURI::root(true) .'/media/system/js/caption.js',
 
);

foreach($doc->_scripts as $key => $script){
    if(in_array($key, $dontInclude)){
        unset($doc->_scripts[$key]);
    }
}

// Detecting Active Variables
$option   = $app->input->getCmd('option', '');
$view     = $app->input->getCmd('view', '');
$layout   = $app->input->getCmd('layout', '');
$task     = $app->input->getCmd('task', '');
$itemid   = $app->input->getCmd('Itemid', '');
$sitename = $app->get('sitename');

// front page selection or by article ID and assign home class 
$contentid = JRequest::getInt('id');
$menu5 = $app->getMenu()->getActive()->id;
if ($contentid == 0) {
 $isHome =null;
 $homeClass = 'home';
} else {
 $isHome = $contentid;
  $menuname = 'menu'. $menu5;
}
 
 //add class to body tag and assign 'article' to non menu item article
  $itemid = JRequest::getVar('Itemid');
  $menu = &JSite::getMenu();
  $active = $menu->getItem($itemid);
  $params = $menu->getParams( $active->id );
  $pageGetClass = $params->get( 'pageclass_sfx' );
  $active = Jfactory::getApplication()->getMenu()->getActive();
  //bring component name, if not content, place name in class,too
  $componentname = JRequest::getVar('option');
$componentname = explode("_",$componentname);

;
  
  if  ($contentid == 0) {
  $pageclass = 'home'; //echo 'foo';  
 	if ($componentname[1] != 'content' ) { 
			$pageclass = $componentname[1] . $pageGetClass ;  //echo 'ru';  
		}
   } 
  elseif  (!$contentid == 0 ) {
  $pageclass = $pageGetClass; //echo 'bar'; 
	if ($menu5 ==101 ) { 
			$pageclass = 'article'; //echo 'ru';  
		}
  }  else {
  
  }
  
// Adjusting content width
if ($this->countModules('right') && $this->countModules('left'))		{$span = "six";}
elseif ($this->countModules('right') && !$this->countModules('left'))	{$span = "nine";}
elseif (!$this->countModules('right') && $this->countModules('left'))	{$span = "nine"; }

else
{ 	$span = "twelve"; }

if (!$isHome):
// Adjusting content width - home page
 
if ($this->countModules('right-home') && $this->countModules('left')){$span = "six";}
elseif ($this->countModules('right-home') && !$this->countModules('left')) {	$span = "nine";}
elseif (!$this->countModules('right-home') && $this->countModules('left')) {	$span = "nine";}
else {	$span = "twelve";}
endif;
	
?>

<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-gb" lang="en-gb" dir="ltr">
<head>
	
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/s/css/font-awesome.min.css"> 		
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/s/skeleton.css?<?php echo rand(); ?>" type="text/css" />
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/s/s.css?<?php echo rand(); ?>" type="text/css" />	
	
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.js"></script>
	<jdoc:include type="head" />

<link href='http://fonts.googleapis.com/css?family=Open+Sans:400,600,700&subset=latin,latin-ext' rel='stylesheet' type='text/css'>
	


<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/js/css/owl.carousel.css" media="screen"> 
<link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/js/css/owl.transitions.css" media="screen">
<script src="<?php echo $this->baseurl ?>/templates/<?php echo $this->template?>/js/owl.carousel.js"></script>
 	<!--[if lt IE 9]>
		<script src="<?php echo $this->baseurl; ?>/media/jui/js/html5.js"></script>
	<![endif]-->
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
</head>

<body class="<?php echo $menuname ?> <?php echo $pageclass ?>  <?php echo $isHome  ? 'content'.htmlspecialchars($isHome ) : ''; ?>">
 <!-- Header -->
<header class="header">
			<div class="topRight">
				<?php if ($this->countModules('topRight')) : ?>
				<jdoc:include type="modules" name="topRight" style="none" />
				<?php endif; ?>		
			</div>

			<a class="logoLnk" href="<?php echo $this->baseurl; ?>"> <img id="logo" src="images/FESE-logo.png" alt="logo" /></a>
				<?php if ($this->countModules('topLeft')) : ?>
				<jdoc:include type="modules" name="topLeft" style="none" />
				<?php endif; ?>	
</header>
	<?php if ($this->countModules('mainNav')) : ?>
	<nav class="navigation orangeBg" role="navigation">
				<jdoc:include type="modules" name="mainNav" style="none" />
	</nav>
	<?php endif; ?>	
<div id="tainer" class="box">
	<?php if ($this->countModules('banner')) : ?>
			<div class="">
				<jdoc:include type="modules" name="banner" style="none" />
			</div>
	<?php endif; ?>
	<?php if (!$isHome): ?>
		<?php if ($this->countModules('banner-home')) : ?>
			<div class="banner">
				<jdoc:include type="modules" name="banner-home" style="none" />
			</div>
		<?php endif; ?>
	<?php endif; ?>
			 
  	<?php if ($this->countModules('left')) : ?>
		<!-- Begin Sidebar -->
			<div id="left" class="columns three">
			  	<jdoc:include type="modules" name="left" style="xhtml" />
			</div>
	<?php endif; ?>
<main id="content" role="main" class="columns <?php echo $span; ?>">
				<!-- Begin Content -->
				<jdoc:include type="modules" name="inContentTop" style="none" />
				<jdoc:include type="message" />
				<jdoc:include type="component" />
				<jdoc:include type="modules" name="inContentBottom" style="none" />
				<!-- End Content -->
</main>
	<?php if ($this->countModules('right')) : ?>
				<!-- Begin Right Sidebar -->
			<div id="right" class="columns three">
				<jdoc:include type="modules" name="right" style="well" />
			</div>				
	<?php endif; ?>
	<?php if (!$isHome): ?>
		<?php if ($this->countModules('right-home')) : ?>
				<!-- Begin Right Sidebar -->
			<div id="right" class="columns three">
				<jdoc:include type="modules" name="right-home" style="well" />
			</div>
		<?php endif; ?>
	<?php endif; ?>
    
	
	<?php if ($this->countModules('user1')) : ?>
				<!-- Begin Right Sidebar -->
				<jdoc:include type="modules" name="user1" style="well" />
	<?php endif; ?>
	
</div>	
	<!-- Footer -->
<footer class="footer" role="contentinfo">
				<jdoc:include type="modules" name="footer" style="none" />
		<a href="#top" id="back-top"><i class="fa fa-angle-up fa-2x"></i> top</a>
</footer>
				<jdoc:include type="modules" name="debug" style="none" />
	<?php if (!$isHome): ?>	
	<script type="text/javascript">
 
	   $('.owl-carousel').owlCarousel({
        items:1,
		loop:true,
		autoplay:true,
    autoplayTimeout:6000,
    autoplayHoverPause:true,
	dots:true,
   nav:true,
	navText: [
      "<i class='fa fa-angle-left fa-2x'></i>",
      "<i class='fa fa-angle-right fa-2x'></i>"
      ],
	    margin:50, stagePadding:20
     });


	  
	</script>
	<?php endif; ?>

<script type="text/javascript">
var _gaq = _gaq || [];
_gaq.push(['_setAccount', 'UA-31772499-1']);
_gaq.push(['_trackPageview']);
(function() {
var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
})();
</script>
	
	</body>
</html>
